import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Properties;

public class PropertiesManager {
	public static final String PROPERTY_FILE_NAME = "Property.xml";
	public static Properties dbProperties;
	public static void loadProperties(){
		dbProperties = new Properties();
		
		try {
			FileInputStream propertyInput = new FileInputStream(PROPERTY_FILE_NAME);
			try {
				dbProperties.loadFromXML(propertyInput);
			} catch (IOException e) {
				System.out.println("Error when loading properties file!");
				System.exit(-1);
			}
		} catch (FileNotFoundException e) {
			System.out.println("Property file not found!");
			System.exit(-1);
		}	
		
	}
	
	public static String getProperty(String propertyName) {
		if(dbProperties == null){
			loadProperties();
		}
		return dbProperties.getProperty(propertyName);
	}
}
