package crawler;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import outputFormat.AmazonProduct;
import outputFormat.LVProduct;
import utility.ExcelManager;
import utility.SiteManager;

public class AmazonCrawler {
	
	//file to write the output on
	private static String outputFile = "excelfile/amazon.xls";
	//site url
	private static String siteurl = "http://www.amazon.com";
	//gender of the product 
	private static String gender;
	//	page to start crawl content
	private static String menPerfume = "http://www.amazon.com/s/qid=1219671933/ref=sr_nr_n_0?ie=UTF8&rs=11056591&keywords=perfume&bbn=11056761&rnid=11056591&rh=i%3Aaps%2Ck%3Aperfume%2Ci%3Abeauty%2Cn%3A3760911%2Cn%3A11056591%2Cn%3A11056761";
	// crawled product counter
	private static int counter = 0;
	
	private static String priceUnit = "USD";
	
	
	public static void main(String[] args){
		AmazonProduct ap = new AmazonProduct();
		ExcelManager.prepareFile(outputFile, ap);
		gender = "men";
		crawlContent(menPerfume);
	}
	private static void crawlContent(String url) {
		//save the page to a String
		String doc = SiteManager.getDocumentFromURL(url, "Baiduspider+(+http://www.baidu.com/search/spider.htm)");
//		System.out.println("-------------------------------------------------------------------");
//		System.out.println("-------------------------------------------------------------------");
//		System.out.println("-------------------------------------------------------------------");
//		System.out.println(doc);
//		System.out.println("-------------------------------------------------------------------");
//		System.out.println("-------------------------------------------------------------------");
//		System.out.println("-------------------------------------------------------------------");
		//find product links
		Pattern prodLinkNameP = Pattern.compile("<a href=\"([^\"]*?)\"><span class=\"srTitle\">([^<]*?)</span></a>");
		Matcher prodLinkNameM = prodLinkNameP.matcher(doc);
		while(prodLinkNameM.find()){
			counter++;
			String link = prodLinkNameM.group(1);
			String name = prodLinkNameM.group(2);
			System.out.println("-------------------------------------------------------------------");
			System.out.print(counter+" product link: "+link);
			System.out.println(" product name: "+name);
			crawlProduct(link, name);
			System.out.println("-------------------------------------------------------------------");
		}
		
		//find next page to crawl
		Pattern nextPageP = Pattern.compile("<a href=\"([^\"]*?)\"([^>]*?)>Next([^>]*?)>");
		Matcher nextPageM = nextPageP.matcher(doc);
		if(nextPageM.find()){
			String nextpage = siteurl+nextPageM.group(1);
			System.out.println("+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++");
			System.out.println("Next page to crawl products: "+nextpage);
			System.out.println("+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++");
			crawlContent(nextpage);
		}
	}
	private static void crawlProduct(String url, String name) {
		//save the page to a String
		String doc = SiteManager.getDocumentFromURL(url, "Baiduspider+(+http://www.baidu.com/search/spider.htm)");
//		System.out.println("-------------------------------------------------------------------");
//		System.out.println("-------------------------------------------------------------------");
//		System.out.println("-------------------------------------------------------------------");
//		System.out.println(doc);
//		System.out.println("-------------------------------------------------------------------");
//		System.out.println("-------------------------------------------------------------------");
//		System.out.println("-------------------------------------------------------------------");
		Pattern imageP = Pattern.compile("src=\"([^\"]*?)\" id=\"prodImage\" width=\"([^\"]*?)\" height=\"([^\"]*?)\"");
		Matcher imageM = imageP.matcher(doc);
		Pattern priceP = Pattern.compile("<b class=\"priceLarge\">$([^<]*?)</b>");
		Matcher priceM = priceP.matcher(doc);
		Pattern descP = Pattern.compile("<b>Product Description</b><br />([^<]*?)<");
		Matcher descM = descP.matcher(doc); 
		if(imageM.find()){
			String image = imageM.group(1);
//			String price = priceM.group(1);
//			String desc = descM.group(0);
			System.out.println("+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++");
			System.out.println("Product image: "+image);
			System.out.println("+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++");
//			System.out.println("Description: "+desc);
		}
		
	}
}
