import java.io.BufferedInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.RandomAccessFile;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.regex.Matcher;
import java.util.regex.Pattern;


public class KelkooCosmeticsCrawler {
	private static String blushersISU = "BLUSHERS_ISU";
	private static String blushersOFN = "BLUSHERS_OFN";
	private static String blushersIF = "etrend/blushers-image/";
	private static String cleaningISU = "CLEANING_ISU";
	private static String cleaningOFN = "CLEANING_OFN";
	private static String cleaningIF = "etrend/cleaning-image/";
	private static String eyesISU = "EYES_ISU";
	private static String eyesOFN = "EYES_OFN";
	private static String eyesIF = "etrend/eyes-image/";
	private static String foundationISU = "FOUNDATIONS_AND_CONCEALERS_ISU";
	private static String foundationOFN = "FOUNDATIONS_AND_CONCEALERS_OFN";
	private static String foundationIF = "etrend/foundation_concealers-image/";
	private static String lipsISU = "LIPS_ISU";
	private static String lipsOFN = "LIPS_OFN";
	private static String lipsIF = "etrend/lips-image/";
	private static String lotionsISU = "LOTIONS_AND_OILS_ISU";
	private static String lotionsOFN = "LOTIONS_AND_OILS_OFN";
	private static String lotionsIF = "etrend/lotions_oils-image/";
	private static String makeupISU = "MAKEUP_BRUSHES_ISU";
	private static String makeupOFN = "MAKEUP_BRUSHES_OFN";
	private static String makeupIF = "etrend/makeup_brushes-image/";
	private static String nailsISU = "NAILS_ISU";
	private static String nailsOFN = "NAILS_OFN";
	private static String nailsIF = "etrend/nails-image/";
	private static String suncareISU = "SUNCARE_ISU";
	private static String suncareOFN = "SUNCARE_OFN";
	private static String suncareIF = "etrend/suncare-image/";
	private static String tanningISU = "TANNING_AND_BRONDZING_ISU";
	private static String tanningOFN = "TANNING_AND_BRONDZING_OFN";
	private static String tanningIF = "etrend/tanning_bronzing-image/";
	
	private static String price_unit = "GBP";
	private static String currentIF;
	private static String nextpageSimple = "Next page";
	private static int line = 0;
	private static String nextpagePostfix = "-~pg-";
	private static int page = 1;
	private static String siteURL;
	private static int itemInPage = 0;
	public static void main(String[] args) {
		KelkooProduct cp = new KelkooProduct();
		String doc;
		page = 1;
		line = 0;
		ExcelManager.prepareFile(PropertiesManager.getProperty(blushersOFN),
				cp);
		siteURL = PropertiesManager.getProperty(blushersISU);
		System.out.println(PropertiesManager.getProperty(blushersISU));
		currentIF = blushersIF;
		doc = SiteManager.getDocumentFromURL(siteURL, "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1)");
		if(doc != null){
			extractData(doc);
		}
		page = 1;
		line = 0;
		ExcelManager.prepareFile(PropertiesManager.getProperty(cleaningOFN),
				cp);
		siteURL = PropertiesManager.getProperty(cleaningISU);
		System.out.println(PropertiesManager.getProperty(cleaningISU));
		currentIF = cleaningIF;
		doc = SiteManager.getDocumentFromURL(siteURL, "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1)");
		if(doc != null){
			extractData(doc);
		}
		page = 1;
		line = 0;
		ExcelManager.prepareFile(PropertiesManager.getProperty(eyesOFN),
				cp);
		siteURL = PropertiesManager.getProperty(eyesISU);
		System.out.println(PropertiesManager.getProperty(eyesISU));
		currentIF = eyesIF;
		doc = SiteManager.getDocumentFromURL(siteURL, "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1)");
		if(doc != null){
			extractData(doc);
		}
		page = 1;
		line = 0;
		ExcelManager.prepareFile(PropertiesManager.getProperty(foundationOFN),
				cp);
		siteURL = PropertiesManager.getProperty(foundationISU);
		System.out.println(PropertiesManager.getProperty(foundationISU));
		currentIF = foundationIF;
		doc = SiteManager.getDocumentFromURL(siteURL, "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1)");
		if(doc != null){
			extractData(doc);
		}
		page = 1;
		line = 0;
		ExcelManager.prepareFile(PropertiesManager.getProperty(lipsOFN),
				cp);
		siteURL = PropertiesManager.getProperty(lipsISU);
		System.out.println(PropertiesManager.getProperty(lipsISU));
		currentIF = lipsIF;
		doc = SiteManager.getDocumentFromURL(siteURL, "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1)");
		if(doc != null){
			extractData(doc);
		}
		page = 1;
		line = 0;
		ExcelManager.prepareFile(PropertiesManager.getProperty(lotionsOFN),
				cp);
		siteURL = PropertiesManager.getProperty(lotionsISU);
		System.out.println(PropertiesManager.getProperty(lotionsISU));
		currentIF = lotionsIF;
		doc = SiteManager.getDocumentFromURL(siteURL, "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1)");
		if(doc != null){
			extractData(doc);
		}
		page = 1;
		line = 0;
		ExcelManager.prepareFile(PropertiesManager.getProperty(makeupOFN),
				cp);
		siteURL = PropertiesManager.getProperty(makeupISU);
		System.out.println(PropertiesManager.getProperty(makeupISU));
		currentIF = makeupIF;
		doc = SiteManager.getDocumentFromURL(siteURL, "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1)");
		if(doc != null){
			extractData(doc);
		}
		page = 1;
		line = 0;
		ExcelManager.prepareFile(PropertiesManager.getProperty(nailsOFN),
				cp);
		siteURL = PropertiesManager.getProperty(nailsISU);
		System.out.println(PropertiesManager.getProperty(nailsISU));
		currentIF = nailsIF;
		doc = SiteManager.getDocumentFromURL(siteURL, "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1)");
		if(doc != null){
			extractData(doc);
		}
		page = 1;
		line = 0;
		ExcelManager.prepareFile(PropertiesManager.getProperty(suncareOFN),
				cp);
		siteURL = PropertiesManager.getProperty(suncareISU);
		System.out.println(PropertiesManager.getProperty(suncareISU));
		currentIF = suncareIF;
		doc = SiteManager.getDocumentFromURL(siteURL, "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1)");
		if(doc != null){
			extractData(doc);
		}
		page = 1;
		line = 0;
		ExcelManager.prepareFile(PropertiesManager.getProperty(tanningOFN),
				cp);
		siteURL = PropertiesManager.getProperty(tanningISU);
		System.out.println(PropertiesManager.getProperty(tanningISU));
		currentIF = tanningIF;
		doc = SiteManager.getDocumentFromURL(siteURL, "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1)");
		if(doc != null){
			extractData(doc);
		}
	}
	
	private static void extractData(String inputText) {
		itemInPage = 0;
		extractItems(inputText);
		if(itemInPage != 0 && findNext(inputText)){
			page++;
			System.out.println("Site page: "+siteURL+nextpagePostfix+page);
			String doc = SiteManager.getDocumentFromURL(siteURL+nextpagePostfix+page, "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1)");
			extractData(doc);
		}
	}
	private static boolean findNext(String doc) {
		if (doc.contains(nextpageSimple)) {
			return true;
		}
		return false;
	}
	private static void extractItems(String doc) {
//		System.out.println(doc);
		String name = "";
		String price = "";
		String image = "";
		String description = "";
		String brand = "";
//		<img class="imgConf" src="http://img.kelkoo.com/uk/medium/990/665/0074938252888781979626684734925296665990.jpg" alt="Elizabeth Arden Colour - Face Cheekcolor Blusher,..." height="90">
		Pattern nameImageP = Pattern.compile("<img([^>]*?)class=\"imgConf\"([^>]*?)src=\"([^>]*?)\"([^>]*?)height=\"90\"([^>]*?)alt=\"([^>]*?)\"([^>]*?)>");
		Matcher nameImageM = nameImageP.matcher(doc);
//		<br>A natural alternative to foundation. Use instead of foundation or blusher especially after using...<br>
//		Brands : Karin Herzog<br>
		Pattern descBrandP = Pattern.compile("<br>([^>]*?)<br>([^>]*?)Brands : ([^>]*?)<br>");
		Matcher descBrandM = descBrandP.matcher(doc);
//		<div class="price">£24.00 </div>
		Pattern priceP = Pattern.compile("<div class=\"price\">&pound;([^>]*?)</div>");
		Matcher priceM = priceP.matcher(doc);
		while(nameImageM.find()&&descBrandM.find()&&priceM.find()){
			line++;
			itemInPage++;
//			System.out.println(priceM.group());
			image = nameImageM.group(3);
			name = nameImageM.group(6);
			description = descBrandM.group(1);
			brand = descBrandM.group(3);
			price = priceM.group(1);
			System.out.println(line+" Name: "+name+" image: "+image+" desc: "+description+" brand: "+brand+" price: "+price);
			try {
				image = SiteManager.saveImage(image, currentIF, line);
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			KelkooProduct kp = new KelkooProduct(line, name, image, brand, price, price_unit, description);
			ExcelManager.writeToFile(kp);
		}
		
	}
}
			

