import java.io.BufferedInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.RandomAccessFile;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.regex.Matcher;
import java.util.regex.Pattern;


public class KelkooFRCrawler {
	private static String kelkooFrOutput = "KKFO";
	private static String kelkooFrPage = "KKFP";
	private static String kelkooIF = "CIF";
	private static int itemInPage;
	private static int line = 0;
	private static String price_unit="EUR";
	private static String nextpagePostfix = "-~pg-";
	private static int page = 1;
	private static String siteURL;
	private static String currentIF;
	private static String nextpageSimple = "Page suivante"; 
	private static String currentURL;
	public static void main(String arg[]){
		line = 0;
		currentIF = PropertiesManager.getProperty(kelkooIF);
		KelkooProduct cp = new KelkooProduct();
		ExcelManager.prepareFile(PropertiesManager.getProperty(kelkooFrOutput),
				cp);
		siteURL = PropertiesManager.getProperty(kelkooFrPage);
		currentURL = siteURL;
		System.out.println("Site page: "+siteURL);
		String doc = SiteManager.getDocumentFromURL(siteURL, "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1)");
		if(doc != null){
			extractData(doc);
		}
	}
	private static void extractData(String inputText) {
		itemInPage = 0;
//		extractItems(inputText);
		extractMenTshirt(inputText);
		if(itemInPage != 0 && findNext(inputText)){
			page++;
			currentURL = siteURL+nextpagePostfix+page;
			System.out.println("Site page: "+siteURL+nextpagePostfix+page);
			String doc = SiteManager.getDocumentFromURL(siteURL+nextpagePostfix+page, "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1; SV1)");
			extractData(doc);
		}
	}
	private static void extractMenTshirt(String doc) {
//		System.out.println(doc);
		String name = "";
		String price = "";
		String image = "";
		String description = "";
		String brand = "";
		
//		<span class="link_sb"><a href="#" onClick="javascript:showProduct('186301', '186301108301fr58bea0b6e20f0f39844fa23259765d82');return false;">T-shirt long femme on n'est pas des anges</a>
//		<span class="cm"><br>DÉBARDEUR CACHEMIRE COL V FEMME BEST. Grand col V. Manches longues. Encolure et emmanchures diminuées. Bord côtes au bas des manches et à la base. Longueur 70 cm. Pour retrouver...</span>
//		</span>
		Pattern nameP = Pattern.compile("<span class=\"link_sb\">(\\s*?)<a href=\"#\" onClick=\"([^>]*?)\">([^<]+?)</a>(\\s*?)<span class=\"cm\"><br>([^<]*?)</span>");
		Matcher nameM = nameP.matcher(doc);
//		<span class="link_sb">
//		<a href="#" onClick="showProduct('3638723','3638723108101freefbac29356146827772b003306c7f54')"><img src="http://img.kelkoo.com/fr/medium/846/327/86045090363174763472184133250969327846.jpg" width="90" height="90" class="logo" border="0"></a>
//		</span>
		Pattern imageP = Pattern.compile("<a href=\"([^\"]*?)\"([^>]*?)><img src=\"([^\"]*?)\"([^>]*?)></a>");
		Matcher imageM = imageP.matcher(doc);
//		<a href="#" onClick="javascript:showProduct('186301', '186301108301frb88781d6f44ddb75b3437e051adf10df');return false;">7,99&nbsp;&euro;</a>
		Pattern priceP = Pattern.compile("<a href=\"#\"([^>]*?)>([^<]*?)&nbsp;&euro;</a>");
		Matcher priceM = priceP.matcher(doc);
		
		while(nameM.find()  && priceM.find() && imageM.find()){
			line++;
			itemInPage++;
//			System.out.println(priceM.group());
			name = nameM.group(3);
			description = nameM.group(5);
			image = imageM.group(3);
			price = priceM.group(2);
			price = price.replace(',', '.');
			brand = findBrand(name);
			brand = brand.trim();
			System.out.println(line+" Name: "+name+" image: "+image+" desc: "+description+" brand: "+brand+" price: "+price);
			try {
				image = SiteManager.saveImage(image, currentIF, line);
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			KelkooProduct kp = new KelkooProduct(line, name, image, brand, price, price_unit, description, currentURL);
			ExcelManager.writeToFile(kp);
		}
		
	}
	private static void extractItems(String doc) {
//		System.out.println(doc);
		String name = "";
		String price = "";
		String image = "";
		String description = "";
		String brand = "";
		
//		<span class="link_sb"><a href="#" onClick="javascript:showProduct('186301', '186301108301fr58bea0b6e20f0f39844fa23259765d82');return false;">T-shirt long femme on n'est pas des anges</a>
//		<span class="cm"><br>DÉBARDEUR CACHEMIRE COL V FEMME BEST. Grand col V. Manches longues. Encolure et emmanchures diminuées. Bord côtes au bas des manches et à la base. Longueur 70 cm. Pour retrouver...</span>
//		</span>
		Pattern nameP = Pattern.compile("<span class=\"link_sb\">(\\s*?)<a href=\"#\" onClick=\"([^>]*?)\">([^<]+?)</a>(\\s*?)<span class=\"cm\"><br>([^<]*?)</span>");
		Matcher nameM = nameP.matcher(doc);
//		<div class="zimg"><a href="http://img.kelkoo.com/fr/xlarge/366/437/53324747722434256455937011557787437366.jpg" target="_blank" class="zoomlink">Zoom</a>
		Pattern imageP = Pattern.compile("<a href=\"([^\"]*?)\"([^>]*?)>Zoom</a>");
		Matcher imageM = imageP.matcher(doc);
//		<a href="#" onClick="javascript:showProduct('186301', '186301108301frb88781d6f44ddb75b3437e051adf10df');return false;">7,99&nbsp;&euro;</a>
		Pattern priceP = Pattern.compile("<a href=\"#\"([^>]*?)>([^<]*?)&nbsp;&euro;</a>");
		Matcher priceM = priceP.matcher(doc);
		
		while(nameM.find() && imageM.find() && priceM.find()){
			line++;
			itemInPage++;
//			System.out.println(priceM.group());
			name = nameM.group(3);
			description = nameM.group(5);
			image = imageM.group(1);
			price = priceM.group(2);
			price = price.replace(',', '.');
			brand = findBrand(name);
			brand = brand.trim();
			System.out.println(line+" Name: "+name+" image: "+image+" desc: "+description+" brand: "+brand+" price: "+price);
			try {
				image = SiteManager.saveImage(image, currentIF, line);
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			KelkooProduct kp = new KelkooProduct(line, name, image, brand, price, price_unit, description, currentURL);
			ExcelManager.writeToFile(kp);
		}
		
	}
	
	private static String findBrand(String name) {
		if(name.indexOf('-') > 0){
			int tp = name.indexOf('-');
			if((name.charAt(tp-1) == name.charAt(tp+1))&& name.charAt(tp-1) == ' ' ){
				return name.substring(0, tp-1);
			}
		}
		return "";
	}
	private static boolean findNext(String doc) {
		if (doc.contains(nextpageSimple)) {
			return true;
		}
		return false;
	}
	
}
