import java.io.File;

import jxl.write.Label;
import jxl.write.WritableCellFormat;
import jxl.write.WritableHyperlink;
import jxl.write.WritableSheet;
import jxl.write.WritableWorkbook;
import jxl.write.WriteException;
import jxl.write.biff.RowsExceededException;


public abstract class Product {	
	protected int id;
	private String name;
	private String image;
	private String brand;
	private String price;
	private String price_unit;
	private String gender;
	private String quantity;
	private String quantity_unit;
	private String description;
	private int score_1;
	private int score_2;
	private int score_3;
	private int score_4;
	private int score_5;
	private float average_rate;
	public Product(){
		
	}
	public Product(int id, String name, String image, String brand, String price, String price_unit, String gender, String quantity, String quantity_unit, String description, int score_1, int score_2, int score_3, int score_4, int score_5, float average_rate) {
		this.id = id;
		this.name = name;
		this.image = image;
		this.brand = brand;
		this.price = price;
		this.price_unit = price_unit;
		this.gender = gender;
		this.quantity = quantity;
		this.quantity_unit = quantity_unit;
		this.description = description;
		this.score_1 = score_1;
		this.score_2 = score_2;
		this.score_3 = score_3;
		this.score_4 = score_4;
		this.score_5 = score_5;
		this.average_rate = average_rate;
	}

	public void creatSheetLabels(WritableSheet sheet, WritableCellFormat cf){
		Label id = new Label(0, 0, "id", cf);
		Label name = new Label(1, 0, "name", cf);
		Label image = new Label(2, 0, "image", cf);
		Label brand = new Label(3, 0, "brand", cf);
		Label price = new Label(4, 0, "price", cf);
		Label price_unit = new Label(5, 0, "price_unit", cf);
		Label gender = new Label(6, 0, "gender", cf);
		Label quantity = new Label(7, 0, "quantity", cf);
		Label quantity_unit = new Label(8, 0, "quantity_unit", cf);
		Label description = new Label(9, 0, "description", cf);
		Label score_1 = new Label(10, 0, "score_1", cf);
		Label score_2 = new Label(11, 0, "score_2", cf);
		Label score_3 = new Label(12, 0, "score_3", cf);
		Label score_4 = new Label(13, 0, "score_4", cf);
		Label score_5 = new Label(14, 0, "score_5", cf);
		Label average_rate = new Label(15, 0, "average_rate", cf);
		
		try {
			sheet.addCell(id);
			sheet.addCell(name);
			sheet.addCell(image);
			sheet.addCell(brand);
			sheet.addCell(price);
			sheet.addCell(price_unit);
			sheet.addCell(gender);
			sheet.addCell(quantity);
			sheet.addCell(quantity_unit);
			sheet.addCell(description);
			sheet.addCell(score_1);
			sheet.addCell(score_2);
			sheet.addCell(score_3);
			sheet.addCell(score_4);
			sheet.addCell(score_5);
			sheet.addCell(average_rate);
			
		} catch (RowsExceededException e) {
			e.printStackTrace();
		} catch (WriteException e) {
			e.printStackTrace();
		}
	}
	
	
	public void writeToSheet(WritableSheet sheet, WritableCellFormat cf) {
		System.out.println("Writing product on the sheet!");
		Label id = new Label(0, this.id, Integer.toString(this.id), cf);
		Label name = new Label(1, this.id, this.name, cf);
		Label image = new Label(2, this.id, this.image, cf);
		Label brand = new Label(3, this.id, this.brand, cf);
		Label price = new Label(4, this.id, this.price, cf);
		Label price_unit = new Label(5, this.id, this.price_unit, cf);
		Label gender = new Label(6, this.id, this.gender, cf);
		Label quantity = new Label(7, this.id, this.quantity, cf);
		Label quantity_unit = new Label(8, this.id, this.quantity_unit, cf);
		Label description = new Label(9, this.id, this.description, cf);
		Label score_1 = new Label(10, this.id, Integer.toString(this.score_1), cf);
		Label score_2 = new Label(11, this.id, Integer.toString(this.score_2), cf);
		Label score_3 = new Label(12, this.id, Integer.toString(this.score_3), cf);
		Label score_4 = new Label(13, this.id, Integer.toString(this.score_4), cf);
		Label score_5 = new Label(14, this.id, Integer.toString(this.score_5), cf);
		Label average_rate = new Label(15, this.id, Float.toString(this.average_rate), cf);
		
		try {
			sheet.addCell(id);
			sheet.addCell(name);
			sheet.addCell(image);
			sheet.addCell(brand);
			sheet.addCell(price);
			sheet.addCell(price_unit);
			sheet.addCell(gender);
			sheet.addCell(quantity);
			sheet.addCell(quantity_unit);
			sheet.addCell(description);
			sheet.addCell(score_1);
			sheet.addCell(score_2);
			sheet.addCell(score_3);
			sheet.addCell(score_4);
			sheet.addCell(score_5);
			sheet.addCell(average_rate);
			
		} catch (RowsExceededException e) {
			e.printStackTrace();
		} catch (WriteException e) {
			e.printStackTrace();
		}	
	}
}
