import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.RandomAccessFile;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * @author xue
 * Copy right reserved, wei xue, LivelyPlanet, Inc.
 */

/**
 * @author xue Crawler to wrap contents from travel-value.de
 */

public class TravelValueCrawler {
	private static String inputFileName = "IFN";

	private static String outputFileName = "OFN";

	private static String imageFolder = "dutyfree/sweets-images/";
	
	private static int line = 0;
	
	private static String brand = "";
	
	private static int totalNbrFiles = 37;
	
	public static void main(String[] args) {
		ChocolateProduct cp = new ChocolateProduct();
		ExcelManager.prepareFile(PropertiesManager.getProperty(outputFileName),
				cp);
		for(int i = 0; i < totalNbrFiles; i++){
			String fileName = PropertiesManager.getProperty(inputFileName+Integer.toString(i));
			System.out.println(PropertiesManager.getProperty(inputFileName+Integer.toString(i)));
			brand = fileName.replace("-chocolate-travel-value-de.txt", "");
			brand = brand.replace("sweets_input_file/", "");
			String inputText = readFile(fileName);
			if (inputText != null)
				extractData(inputText);
		}
	}

	private static void extractData(String inputText) {
		String imageAddress = "";
		String productName = "";
		String price = "";
		String price_unit = "";
		String quantity = "";
		String quantity_unit = "";
		// <img vsds="T1Q_Artikel" name="imgT1BILD_KLEIN" alt="Thumbnail"
		// src="http://www.travel-value.de/images/01/so/636486.jpg"
		// vsdf="BILD_KLEIN" border="0">
		//		<img vsds="T1Q_Artikel" name="imgT1BILD_KLEIN" alt="Thumbnail" src="http://www.travel-value.de/images/01/so/791185.jpg" vsdf="BILD_KLEIN" border="0">
		Pattern imageP = Pattern
		.compile(">(\\s*?)<img(.*?)src=\"([^\"]*?)\"(.*?)border=\"0\">");
		Matcher imageM = imageP.matcher(inputText);
		// <a
		// href="javascript:submitForm(document.pQ_Artikel_Grid,'TE1_1528933377_hrefT2pQ_Artikelbild=TE1_1528933377_hrefT2pQ_Artikelbild&vsnavigation=T2pQ_Artikelbild',
		// 	'Results');" class="hyper_einfach" vsnavigation="T2pQ_Artikelbild"
		// name="TE1_1528933377_hrefT2pQ_Artikelbild" vsaction="pagetransition">Asbach
		// Privatmischung in tin</a>
		Pattern productNameP = Pattern.compile("<td><a([^>]*?)>([^<]*?)</a></td>");
		Matcher productNameM = productNameP.matcher(inputText);
//		</td>
//        <td class="artikelliste" align="right" nowrap="nowrap">300</td>
//        <td class="artikelliste" align="left" nowrap="nowrap">g</td>
//        <td class="artikelliste" align="right" nowrap="nowrap">9.50</td>
//        <td class="artikelliste" align="left" nowrap="nowrap">EUR</td>
//      </tr>
		Pattern priceQuantityP = Pattern.compile("</td>(\\s*?)<td class=\"artikelliste\"([^>]*?)>([^<]*?)</td>(\\s*?)<td([^>]*?)>([^<]*?)</td>(\\s*?)<td([^>]*?)>([^<]*?)</td>(\\s*?)<td([^>]*?)>([^<]*?)</td>(\\s*?)</tr>");
		Matcher priceQuantityM = priceQuantityP.matcher(inputText);
		while (imageM.find() && productNameM.find() && priceQuantityM.find()) {
			System.out.println(imageM.group(3));
			line++;
			productName = productNameM.group(2);
			imageAddress = imageM.group(3);
			quantity = priceQuantityM.group(3);
			quantity_unit = priceQuantityM.group(6);	
			price = priceQuantityM.group(9);
			price_unit = priceQuantityM.group(12);
			System.out.println("Price: "+price+" price_unit: "+price_unit+" quantity: "+quantity+" quantity_unit: "+quantity_unit);
			try {
				if (imageAddress.contains(" "))
					imageAddress.replaceAll(" ", "%20");
				URL url = new URL(imageAddress);
				InputStream in = null;
				try {
					in = new BufferedInputStream(url.openStream());
					File imageRep = new File(imageFolder);
					if (!imageRep.exists()) {
						imageRep.mkdir();
					}
					// downloaded bytes
					ByteArrayOutputStream out = new ByteArrayOutputStream();
					// output file
					imageAddress = imageFolder
							+ line
							+ imageAddress.substring(imageAddress
									.lastIndexOf("."));
					RandomAccessFile file = new RandomAccessFile(imageAddress,
							"rw");
					// download buffer
					byte[] buffer = new byte[4096];

					// download the bytes
					for (int read = 0; (read = in.read(buffer)) != -1; out
							.write(buffer, 0, read))
						;
					// write all data out to the file
					file.write(out.toByteArray());
					// close file
					file.close();
					System.out.println("image : " + imageAddress);
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}

			} catch (MalformedURLException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			ChocolateProduct cp = new ChocolateProduct(line, productName, imageAddress, brand, price, price_unit, quantity, quantity_unit);
			ExcelManager.writeToFile(cp);
		}
	}

	private static String readFile(String fileName) {
		System.out.println("Reading file: " + fileName);
		StringBuffer doc = new StringBuffer();
		try {
			BufferedReader br = new BufferedReader(new FileReader(fileName));
			String line = br.readLine();
			while (line != null) {
				doc.append(line + "\n");
				line = br.readLine();
			}
			System.out.println("File read.");
			return doc.toString();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return null;
	}
}
